#include	"Hidef.h"

#include	"MC9S12NE64.h"
#include	"PortDef.h"

#include	"string.h"
#include	"Struct.h"
#include	"Prototype.h"

UINT8 RxBufferA[2] @0x2000;
UINT8 RxBufferB[2] @0x2600;

const UINT8	MyMAC[6] @ 0xff90;		// My MAC adrs


typedef void(*CallbackFuncEther)(EtherBuf *);
CallbackFunc16 PPPSendHook @0x3d00;	// Send hook	
CallbackFuncV	PPPHandlerHook @0x3d02;	// PPP handler hook (PPP_Handler)
CallbackFuncEther BridgeSendHook @0x3d04;// Bridge send hook (BridgePPPSend)
CallbackFuncV	SystemThreadHook @0x3d06;	// PPP handler hook (PPP_Handler)
CallbackFunc16	GatewayHook @0x3d08;	// PPP handler hook (PPP_Handler)

UINT8 *PassWord @0x3D0A;
UINT32 BootIP @0x3D0C;
UINT32 BootGW @0x3D10;
UINT32 BootMask @0x3D14;
UINT32 DnsIP @0x3D18;
UINT32 MyIP @0x3D1C;
UINT32 DefGW @0x3D20;
UINT32 SubMask @0x3D24;
UINT8 PPP_Mode @0x3D28;
UINT8 ConfigByte @0x3D29;
UINT8 *TxBuffer @0x3D2A;
UINT8 TxBufBusy @0x3D2C;

#pragma	MESSAGE DISABLE C3604
#pragma	MESSAGE DISABLE C1404
#pragma	MESSAGE DISABLE C5703

#pragma NO_RETURN 
void	SystemSleep(void)
{
	asm
	{
		jsr	0x4003
		dc.b	0
	}
}

#pragma NO_RETURN
UINT8 CreateThread(UINT16 adrs, UINT16 stacksize, UINT16 arg)
{
	asm
	{
		jsr	0x4003
		dc.b	1
	}
}

#pragma NO_RETURN
void *MemoryAlloc(UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	2
	}
}

#pragma NO_RETURN
void MemoryFree(void *mem)
{
	asm
	{
		jsr	0x4003
		dc.b	3
	}
}

#pragma NO_RETURN
UINT8 CreateTimer(UINT8 mode, CallbackFunc8 func, UINT16 val, UINT8 timer, UINT8 stack)
{
	asm
	{
		jsr	0x4003
		dc.b	4
	}
}

#pragma NO_RETURN
UINT16	GetTimerCount(UINT8 timer)
{
	asm
	{
		jsr	0x4003
		dc.b	5
	}
}

#pragma NO_RETURN
void Sleep(UINT16 time)
{
	asm
	{
		jsr	0x4003
		dc.b	6
	}
}

#pragma NO_RETURN
void WaitCriticalSession(UINT8 *flag)
{
	asm
	{
		jsr	0x4003
		dc.b	7
	}
}

//
//	FileSys
//
#pragma NO_RETURN
void FormatFilesys(UINT16 key)
{
	asm
	{
		jsr	0x4003
		dc.b	8
	}
}

#pragma NO_RETURN
void DefragFilesys(UINT16 key)
{
	asm
	{
		jsr	0x4003
		dc.b	9
	}
}

#pragma NO_RETURN
UINT32 GetFinalPos(void)
{
	asm
	{
		jsr	0x4003
		dc.b	10
	}
}

#pragma NO_RETURN
UINT8 CreateFile(INT8 *filename)
{
	asm
	{
		jsr	0x4003
		dc.b	11
	}
}

#pragma NO_RETURN
UINT16	WriteFile(void *ptr, UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	12
	}
}

#pragma NO_RETURN
void CloseFile(UINT16 handle)
{
	asm
	{
		jsr	0x4003
		dc.b	13
	}
}

#pragma NO_RETURN
UINT8 DeleteFile(INT8 *filename)
{
	asm
	{
		jsr	0x4003
		dc.b	14
	}
}

#pragma NO_RETURN
UINT8 MoveFile(INT8 *filename, INT8 *newfile)
{
	asm
	{
		jsr	0x4003
		dc.b	15
	}
}

#pragma NO_RETURN
INT8 *FindFile(UINT8 init)
{
	asm
	{
		jsr	0x4003
		dc.b	16
	}
}

#pragma NO_RETURN
UINT32	GetFileSize(INT8 *filename)
{
	asm
	{
		jsr	0x4003
		dc.b	17
	}
}

#pragma NO_RETURN
UINT16	OpenFile(INT8 *filename)
{
	asm
	{
		jsr	0x4003
		dc.b	18
	}
}

#pragma NO_RETURN
UINT16	ReadFile(UINT16 handle, UINT8 *buf, UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	19
	}
}

#pragma NO_RETURN
UINT32	SeekFile(UINT16 fp, UINT32 pos, UINT8 org)
{
	asm
	{
		jsr	0x4003
		dc.b	20
	}
}

//
//	Bios
//
#pragma NO_RETURN
void BufCopy(void *dest, void *src, UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	21
	}
}

#pragma NO_RETURN
void MemClear(void *dest, UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	22
	}
}

//
//	UDP
//
#pragma NO_RETURN
UINT16 GetFreePort(void)
{
	asm
	{
		jsr	0x4003
		dc.b	23
	}
}

#pragma NO_RETURN
INT8 CreateSocket(UINT8 prot)
{
	asm
	{
		jsr	0x4003
		dc.b	24
	}
}

#pragma NO_RETURN
UINT8 Bind(INT8 sochandle, UINT16 port, UINT8 maxsoc)
{
	asm
	{
		jsr	0x4003
		dc.b	25
	}
}

#pragma NO_RETURN
void CloseSocket(INT8 sochandle)
{
	asm
	{
		jsr	0x4003
		dc.b	26
	}
}

#pragma NO_RETURN
UINT32 GetSenderIP(INT8 sochandle)
{
	asm
	{
		jsr	0x4003
		dc.b	27
	}
}

#pragma NO_RETURN
UINT16 GetSenderPort(INT8 sochandle)
{
	asm
	{
		jsr	0x4003
		dc.b	28
	}
}

#pragma NO_RETURN
UINT8 *GetReceiveBuffer(INT8 sochandle, UINT8 release)
{
	asm
	{
		jsr	0x4003
		dc.b	29
	}
}

#pragma NO_RETURN
INT16 SendTo(INT8 sochandle, UINT32 ip, UINT16 port, UINT8 *buf, UINT16 len)
{
	asm
	{
		jsr	0x4003
		dc.b	30
	}
}

#pragma NO_RETURN
INT16 RecvFrom(INT8 sochandle, UINT16 timeout)
{
	asm
	{
		jsr	0x4003
		dc.b	31
	}
}

#pragma NO_RETURN
INT16 GetDefMtu(INT8 sochandle, UINT16 mtu)
{
	asm
	{
		jsr	0x4003
		dc.b	32
	}
}

#pragma NO_RETURN
INT8 Connect(INT8 sochandle, UINT32 ip, UINT16 port)
{
	asm
	{
		jsr	0x4003
		dc.b	33
	}
}

#pragma NO_RETURN
INT8 Accept(INT8 sochandle, UINT16 timeout)
{
	asm
	{
		jsr	0x4003
		dc.b	34
	}
}

#pragma NO_RETURN
INT16 Read(INT8 sochandle, UINT16 timeout)
{
	asm
	{
		jsr	0x4003
		dc.b	35
	}
}

#pragma NO_RETURN
INT16 Write(INT8 sochandle, UINT8 *buf, UINT16 len)
{
	asm
	{
		jsr	0x4003
		dc.b	36
	}
}

#pragma NO_RETURN
INT8 CheckWriteComplete(INT8 sochandle)
{
	asm
	{
		jsr	0x4003
		dc.b	37
	}
}

#pragma NO_RETURN
INT8 WaitWriteComplete(INT8 sochandle)
{
	asm
	{
		jsr	0x4003
		dc.b	38
	}
}

//
//	Resolve
//
#pragma NO_RETURN
UINT32 GetHostByName(UINT8 *name)
{
	asm
	{
		jsr	0x4003
		dc.b	39
	}
}

//
//	Registry
//
#pragma NO_RETURN
void LoadRegistry(VarEntry* RegTable)
{
	asm
	{
		jsr	0x4003
		dc.b	40
	}
}

#pragma NO_RETURN
INT8 SaveRegistry(VarEntry* RegTable)
{
	asm
	{
		jsr	0x4003
		dc.b	41
	}
}

#pragma NO_RETURN
void UpdateString(VarEntry* RegTable)
{
	asm
	{
		jsr	0x4003
		dc.b	42
	}
}

#pragma NO_RETURN
void DebugPutc(UINT8 c)
{
	asm
	{
		jsr	0x4003
		dc.b	43
	}
}

#pragma NO_RETURN
void DebugPuts(void *s)
{
	asm
	{
		jsr	0x4003
		dc.b	44
	}
}

#pragma NO_RETURN
void DebugPutHex(UINT8 c)
{
	asm
	{
		jsr	0x4003
		dc.b	45
	}
}

#pragma NO_RETURN
void DebugPutHex2(UINT16 c)
{
	asm
	{
		jsr	0x4003
		dc.b	46
	}
}

#pragma NO_RETURN
void DebugPutNum(INT32 c)
{
	asm
	{
		jsr	0x4003
		dc.b	47
	}
}

#pragma NO_RETURN
void SetUserProgram(UINT8 *buf, UINT16 adrs)
{
	asm
	{
		jsr	0x4003
		dc.b	48
	}
}

#pragma NO_RETURN
void GetDigit(INT32 num, UINT8 *buf)
{
	asm
	{
		jsr	0x4003
		dc.b	49
	}
}

//
//	Set SCI interrupt vector
//	vecnum:0=SCI0RX 1=SCI0TX 2=SCI0ERR
//	vecnum:3=SCI1RX 4=SCI1TX 5=SCI1ERR
//
#pragma NO_RETURN
void SetSciVector(UINT8 vecnum, void *adrs)
{
	asm
	{
		jsr	0x4003
		dc.b	50
	}
}

//
//	Sense key hit
//
#pragma NO_RETURN
UINT8 SciSense(UINT8 ch)
{
	asm
	{
		jsr	0x4003
		dc.b	51
	}
}

//
//	Sci Wait key board and Get 1 char
//
#pragma NO_RETURN
UINT8 SciGetc(UINT8 ch)
{
	asm
	{
		jsr	0x4003
		dc.b	52
	}
}

//
//	Sci put 1 char
//
#pragma NO_RETURN
void SciPutc(UINT8 c, UINT8 ch)
{
	asm
	{
		jsr	0x4003
		dc.b	53
	}
}

//
//	Sci put 1 line
//
#pragma NO_RETURN
void SciPuts(INT8 *s, UINT8 ch)
{
	asm
	{
		jsr	0x4003
		dc.b	54
	}
}

//
//	Get adrs info
//
#pragma NO_RETURN
UINT32 *GetIpAdrs(void)
{
	asm
	{
		jsr	0x4003
		dc.b	55
	}
}

//
//	Replace CGI symbol
//
#pragma NO_RETURN
UINT8 *ReplaceCgi(UINT8 *buf, UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	56
	}
}

//
//	Dispatch IP packet (for PPP)
//
#pragma NO_RETURN
void DispatchPacket(EtherBuf *etherbuf)
{
	asm
	{
		jsr	0x4003
		dc.b	57
	}
}

//
//	ARP Init(for PPP)
//
#pragma NO_RETURN
void ArpInit(void)
{
	asm
	{
		jsr	0x4003
		dc.b	58
	}
}

//
//	ARP find (for PPP)
//
#pragma NO_RETURN
ArpTable* ArpFind(UINT32 ip)
{
	asm
	{
		jsr	0x4003
		dc.b	59
	}
}

//
//	Ether init (for PPP)
//
#pragma NO_RETURN
void EtherInit(UINT8 enable)
{
	asm
	{
		jsr	0x4003
		dc.b	60
	}
}

//
//	Ether packet send (for PPP)
//
#pragma NO_RETURN
void EtherSend(UINT8 *buf, UINT16 len)
{
	asm
	{
		jsr	0x4003
		dc.b	61
	}
}

//
//	EMAC enable/disable (for PPP)
//
#pragma NO_RETURN
void EmacEnable(UINT8 enable)
{
	asm
	{
		jsr	0x4003
		dc.b	62
	}
}

//
//	DHCP init(for PPP)
//
#pragma NO_RETURN
void DhcpInit(UINT8 server)
{
	asm
	{
		jsr	0x4003
		dc.b	63
	}
}

//
//	TFTP init(for PPP)
//
#pragma NO_RETURN
void TftpInit(void)
{
	asm
	{
		jsr	0x4003
		dc.b	64
	}
}

//
//	HTTP init(for PPP)
//
#pragma NO_RETURN
void HttpInit(void)
{
	asm
	{
		jsr	0x4003
		dc.b	65
	}
}

//
//	NVM erase
//
#pragma NO_RETURN
UINT8 NvmErase(UINT16 *adrs)
{
	asm
	{
		jsr	0x4003
		dc.b	66
	}
}

//
//	NVM program
//
#pragma NO_RETURN
UINT8 NvmWrite(UINT16 *adrs, UINT16 *src, UINT16 size)
{
	asm
	{
		jsr	0x4003
		dc.b	67
	}
}

//
//	NVM program S-record
//
#pragma NO_RETURN
void WriteSrecord(INT8 *Buf)
{
	asm
	{
		jsr	0x4003
		dc.b	68
	}
}

//
//	KillMyThread
//
#pragma NO_RETURN
void KillThread(UINT8 handle)
{
	asm
	{
		jsr	0x4003
		dc.b	69
	}
}

//
//	DoCgi
//
#pragma NO_RETURN
void DoCgi(UINT8 *Buf)
{
	asm
	{
		jsr	0x4003
		dc.b	70
	}
}

//
//	IpPacketSend
//
#pragma NO_RETURN
UINT8 IpPacketSend(UINT32 ip, UINT8 prot, UINT8 *hdr, UINT8 hlen, UINT8 *buf, UINT16 len)
{
	asm
	{
		jsr	0x4003
		dc.b	71
	}
}
