#include	"MOTTYPES.h"
#include	"hidef.h"
#include	"MC9S12NE64.h"

//
//	Common port settings
//
		#define	LEDON		0
		#define	LEDOFF	1

		#define	ACT_ON		PTL_PTL1 = LEDOFF
		#define	ACT_OFF		PTL_PTL1 = LEDON
		#define	ACT_OUT		DDRL_DDRL1 = 1

		#define	LINK_ON		PTL_PTL2 = LEDOFF
		#define	LINK_OFF	PTL_PTL2 = LEDON
		#define	LINK_OUT	DDRL_DDRL2 = 1
		#define	LINK			PTL_PTL2

		#define	LEDA_ON		PTL_PTL3 = LEDON
		#define	LEDA_OFF	PTL_PTL3 = LEDOFF
		#define	LEDA_XOR	PTL_PTL3 ^= 1
		#define	LEDA_OUT	DDRL_DDRL3 = 1

		#define	LEDB_ON		PTL_PTL4 = LEDON
		#define	LEDB_OFF	PTL_PTL4 = LEDOFF
		#define	LEDB_XOR	PTL_PTL4 ^= 1
		#define	LEDB_OUT	DDRL_DDRL4 = 1

		#define	PRESSED	0

//
//	Device dependent port settings
//

	#ifdef	SMALL	// Small 1st generation board

		#define	LED1_ON
		#define	LED1_OFF
		#define	LED1_XOR
		#define	LED1_OUT

		#define	LED2_ON
		#define	LED2_OFF
		#define	LED2_XOR
		#define	LED2_OUT

		#define	LED3_ON
		#define	LED3_OFF
		#define	LED3_XOR
		#define	LED3_OUT

		#define	LED4_ON
		#define	LED4_OFF
		#define	LED4_XOR
		#define	LED4_OUT

		#define	PUSHBUTTON1
		#define	PUSHBUTTON2
		#define	PUSHBUTTON3
		#define	PUSHBUTTON4

		#define	RL1_ON
		#define	RL1_OFF
		#define	RL1_OUT
		#define	RL2_ON
		#define	RL2_OFF
		#define	RL2_OUT

		#define	RTSCOM_ON	PTG_PTG3 = 0
		#define	RTSCOM_OFF	PTG_PTG3 = 1
		#define	RTSCOM_OUT	DDRG_DDRG3 = 1
		#define	CTSCOM			PTG_PTG4
		#define	CTSCOM_PE		PERG_PERG4 = 1

	#endif

	#ifdef	PROTO		// Silent Relay board

		#define	LED1_ON		PTH_PTH1 = LEDON
		#define	LED1_OFF	PTH_PTH1 = LEDOFF
		#define	LED1_XOR	PTH_PTH1 ^= 1
		#define	LED1_OUT	DDRH_DDRH1 = 1

		#define	LED2_ON		PTH_PTH2 = LEDON
		#define	LED2_OFF	PTH_PTH2 = LEDOFF
		#define	LED2_XOR	PTH_PTH2 ^= 1
		#define	LED2_OUT	DDRH_DDRH2 = 1

		#define	LED3_ON		PTH_PTH3 = LEDON
		#define	LED3_OFF	PTH_PTH3 = LEDOFF
		#define	LED3_XOR	PTH_PTH3 ^= 1
		#define	LED3_OUT	DDRH_DDRH3 = 1

		#define	LED4_ON		PTH_PTH4 = LEDON
		#define	LED4_OFF	PTH_PTH4 = LEDOFF
		#define	LED4_XOR	PTH_PTH4 ^= 1
		#define	LED4_OUT	DDRH_DDRH4 = 1

		#define	PUSHBUTTON1	PTH_PTH5
		#define	PUSHBUTTON2	PTH_PTH6
		#define	PUSHBUTTON3	PTJ_PTJ6
		#define	PUSHBUTTON4	PTJ_PTJ7

		#define	RL1_ON	PTH_PTH0	= 1
		#define	RL1_OFF	PTH_PTH0	= 0
		#define	RL1_OUT	DDRH_DDRH0 = 1
		#define	RL2_ON	PTT_PTT4	= 1
		#define	RL2_OFF	PTT_PTT4	= 0
		#define	RL2_OUT	DDRT_DDRT4 = 1

		#define	RTSCOM_ON		PTG_PTG5 = 0	
		#define	RTSCOM_OFF	PTG_PTG5 = 1	
		#define	RTSCOM_OUT	DDRG_DDRG5 = 1
		#define	CTSCOM			PTG_PTG6
		#define	CTSCOM_PE		PERG_PERG6 = 1

	#endif	

	#ifdef	MP		// Silent Relay board

		#define	LED1_ON		PTH_PTH4 = LEDON
		#define	LED1_OFF	PTH_PTH4 = LEDOFF
		#define	LED1_XOR	PTH_PTH4 ^= 1
		#define	LED1_OUT	DDRH_DDRH4 = 1

		#define	LED2_ON		PTH_PTH5 = LEDON
		#define	LED2_OFF	PTH_PTH5 = LEDOFF
		#define	LED2_XOR	PTH_PTH5 ^= 1
		#define	LED2_OUT	DDRH_DDRH5 = 1

		#define	LED3_ON		PTH_PTH6 = LEDON
		#define	LED3_OFF	PTH_PTH6 = LEDOFF
		#define	LED3_XOR	PTH_PTH6 ^= 1
		#define	LED3_OUT	DDRH_DDRH6 = 1

		#define	LED4_ON		PTJ_PTJ6 = LEDON
		#define	LED4_OFF	PTJ_PTJ6 = LEDOFF
		#define	LED4_XOR	PTJ_PTJ6 ^= 1
		#define	LED4_OUT	DDRJ_DDRJ6 = 1

		#define	PUSHBUTTON1	PTH_PTH0
		#define	PUSHBUTTON2	PTH_PTH1
		#define	PUSHBUTTON3	PTH_PTH2
		#define	PUSHBUTTON4	PTH_PTH3

		#define	RL1_ON	PTJ_PTJ7	= 1
		#define	RL1_OFF	PTJ_PTJ7	= 0
		#define	RL1_OUT	DDRJ_DDRJ7 = 1
		#define	RL2_ON	PTT_PTT4	= 1
		#define	RL2_OFF	PTT_PTT4	= 0
		#define	RL2_OUT DDRT_DDRT4 = 1

		#define	RTSCOM			PTG_PTG5
		#define	RTSON				0
		#define	RTSOFF			1
		#define	RTSCOM_ON		PTG_PTG5 = RTSON	
		#define	RTSCOM_OFF	PTG_PTG5 = RTSOFF	
		#define	RTSCOM_OUT	DDRG_DDRG5 = 1
		#define	CTSCOM			PTG_PTG6
		#define	CTSCOM_PE		PERG_PERG6 = 1

	#endif	
