//
//	Structure headder
//
#include  "MOTTYPES.h"

//
//	String macros
//
#define	StrCpy(x,y)	strcpy((INT8*)(x), (INT8*)(y))
#define	StrCat(x,y)	strcat((INT8*)(x), (INT8*)(y))
#define	StrCmp(x,y)	strcmp((INT8*)(x), (INT8*)(y))
#define	StrLen(x)		strlen((INT8*)(x))

//
//	High/Low macros
//
#define	LOWBYTE(X)	((X) & 255)
#define	HIGHBYTE(X)	((X) >> 8)

//
//	Definition for hook table
//
typedef void (*HookFunction)(void);
//
//	Prototypes for all
//
typedef void(*CallbackFunc16)(UINT16);
typedef void(*CallbackFunc8)(UINT8);
typedef void(*CallbackFuncV)(void);

//
//	Jump table structure  (06, HH, LL)
//
typedef struct	
{												// JMP adrs table from 0x3f91
	UINT8					opcode;	// Will be 0x06 (JMP instruction)
	HookFunction	adrs;		// Will be address (2 byte)
}	JumpTable;

//
//	Ether buffer control table
//
typedef struct
{		
//	Ether layer
	INT8		ch;				// A or B ch id
	INT16		len;			// Total packet length
	UINT8		*data;		// Buffer adrs
//	IP layer
	UINT16	datalen;	// Data length (with IP header)
	UINT32	ip;				// Source IP address
	UINT16	remport;	// Source port num
	UINT16	locport;	// Destinetion port num
} EtherBuf;	

//
//	ARP cache table structure	
//
typedef struct
{
	UINT8	state;		// ARP_FREE, ARP_PENDING, ARP_RESOLVED, ARP_REFRESH
	UINT8	type;			// ARP_FIXED_IP, ARP_TEMP_IP, ARP_MY_IP				
	UINT8	retry;		// ARP retry count
	UINT8	life;			// Time to live
	UINT8	MAC[6];	// MAC adrs
	UINT32	ipadrs;	// IP address
} ArpTable;

//
//	Socket structure
//
typedef struct
{
	UINT8		status;		// Status		
	UINT8		handle;		// SocTable index
	UINT8		tcpstate;	// TCP state
	UINT8		flags;		// TCP session flag
	UINT8		maxhandle;// Max scoket creation limit
	UINT8		rootsoc;	// Root socket handle

	UINT8		*recptr;	// Recieve buffer pointer
	UINT16	reclen;		// Received length
	UINT8		*sendptr;	// Send buffer
	UINT16	sendlen;	// Send buffer length

	UINT16	locport;	// Local port receive or transmit
	UINT16	remport;	// Senders port
	UINT16	defmtu;		// MTU value for each session

	UINT32	remip;		// IP adrs
	UINT32	curseq;		// Current seq num
	UINT32	curack;		// Current ack num
  UINT32	sentack;	// Last sent ack (for duplicate packets ACK reply match)

	UINT8		retrycount;	// Retry count
	UINT8		retrytimer;	// Retry timer handle
	UINT8		alivetimer;	// Alive timer handle
	UINT8		option;		// Keep protocol to create socket (for telnet use forever mode)
} socket;

//	Max scket number
#define	MAXSOCKET	9	// MAX socket number is 8 (0 is reserved)

//
//	Registry entry structure
//
typedef struct
{
	INT8	*name;	// Var name
	void	*adrs;	// Var pointer
	UINT8	len;		// String or Integer length or bit pos
	UINT8	attr;		// 1 0-7:bit 9:byte 10:word 12:dword 80-FF:string (&7f is length)	
} VarEntry;

